# Servlet API friendly extensions to Rack
# Allows for forwarding the request to another servlet/JSP 
# as well as server-side include of content generated by a servlet/JSP
java_import org.jruby.rack.servlet.ServletRackIncludedResponse

module Rack
  class Request
    def forward_to(path, params={})
      servlet_request = env['java.servlet_request']
      params.each { |k,v| servlet_request[k.to_s] = v}
      servlet_response = env['java.servlet_response']
      servlet_request.getRequestDispatcher(path).forward(servlet_request, servlet_response)
    end

    # Returns the output of the server-side include as a string, honoring the character
    # encoding set on the response.
    def render(path, params={})
      servlet_request = env['java.servlet_request']
      params.each { |k,v| servlet_request[k.to_s] = v}
      servlet_response = ServletRackIncludedResponse.new(env['java.servlet_response'])
      servlet_request.getRequestDispatcher(path).include(servlet_request, servlet_response)
      servlet_response.getOutput
    end
  end
end

